#version 330 core
/*
    Voxelverse

    Copyright (c) 2022, Voxelverse Team.
    All rights reserved.
        
    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions are met:
        
    Redistributions of source code must retain the above copyright notice, this
    list of conditions and the following disclaimer.
    
    Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.
    
    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
    AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
    DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
    FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
    DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
    SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
    CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
    OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
    OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

uniform mat4 uProjMatrix;
uniform mat4 uViewMatrix;
uniform mat4 uModelMatrix;
uniform vec2 uTexOffset;

layout (location = 0) in vec3 attrPos;
layout (location = 1) in vec2 attrTexCoords;
layout (location = 2) in vec3 attrNormal;
layout (location = 3) in vec3 attrUVec;
layout (location = 4) in vec3 attrVVec;

out vec2 passTexCoords;
out vec3 passNormal;
out vec4 passPos;
out vec3 passUVec;
out vec3 passVVec;

void main()
{
    gl_Position = uProjMatrix * uViewMatrix * uModelMatrix * vec4(attrPos, 1.0);
    passPos = uModelMatrix * vec4(attrPos, 1.0);
    passTexCoords = attrTexCoords + uTexOffset;
    passNormal = vec3(uModelMatrix * vec4(attrNormal, 0.0));
    passUVec = attrUVec;
    passVVec = attrVVec;
}